.master:
  before_script:
    - cd ..
    - >
      if [ -d "test-root" ]; then
        rm -fr test-root 
      fi
    - >
      if [ -d "master" ]; then
        rm -fr master
      fi
    - >
      if [ -d "pipeline-tools" ]; then
        rm -fr pipeline-tools
      fi
    - |
      git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.jayeson.com.sg/cid/master --single-branch --depth 1
      git clone git@gitlab.jayeson.com.sg:devops/pipeline-tools.git --branch $PIPELINE_TOOLS --single-branch --depth 1
      cp pipeline-tools/build/gradle4.properties master/gradle.properties

.testroot:
  before_script:
    - cd ..
    - > 
      if [ -d "test-root" ]; then
        rm -fr test-root
      fi
    - >
      if [ -d "master" ]; then
        rm -fr master
      fi
    - >
      if [ -d "pipeline-tools" ]; then
        rm -fr pipeline-tools
      fi
    - |
      git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.jayeson.com.sg/test/test-root --single-branch --depth 1
      git clone git@gitlab.jayeson.com.sg:devops/pipeline-tools.git --branch $PIPELINE_TOOLS --single-branch --depth 1
      rm -f test-root/build.gradle
      mv pipeline-tools/build/build.gradle5 test-root/build.gradle
      mv test-root/settings-sample.gradle test-root/settings.gradle
      echo "includeFlat '$CI_PROJECT_NAME'" >> test-root/settings.gradle

.testroot:monorepo:
  before_script:
    - cd ..
    - > 
      if [ -d "test-root" ]; then
        rm -fr test-root
      fi
    - >
      if [ -d "master" ]; then
        rm -fr master
      fi
    - >
      if [ -d "pipeline-tools" ]; then
          rm -fr pipeline-tools
        fi
    # If exists file build.gradle and setting.gradle
    # in the project; then
    #   Using these file for build
    # Else
    #   Get file from pipeline-tool
    - >
      if [ -f $CI_PROJECT_NAME/build.gradle ] && [ -f $CI_PROJECT_NAME/settings.gradle ]; then
        echo "Using existing build.gradle and setting.gradle in project $CI_PROJECT_NAME"
        ln -s $CI_PROJECT_NAME test-root
      else
        echo "Setting up for build.gradle and setting.gradle from pipeline-tools"
        git clone https://gitlab-ci-token:${CI_JOB_TOKEN}@gitlab.jayeson.com.sg/test/test-root --single-branch --depth 1
        git clone git@gitlab.jayeson.com.sg:devops/pipeline-tools.git --branch $PIPELINE_TOOLS --single-branch --depth 1
        rm -f test-root/build.gradle
        mv pipeline-tools/build/build.gradle.monorepo test-root/build.gradle
        mv test-root/settings-sample.gradle test-root/settings.gradle

        echo "include '$projectExecution'" >> test-root/settings.gradle
        echo "project(':$projectExecution').projectDir = new File('../$CI_PROJECT_NAME/$PROJECT_PATH')" >> test-root/settings.gradle
      fi


.cleanup:
  after_script:
    # This varialbe PUBLISH_VER is very essential for deploy stage
    # As it plays a role like version we will deploy
    - >
      export PUBLISH_VER="";
      if [ -f "build/publishSummary.txt" ]; then
        PUBLISH_VER="$(cat build/publishSummary.txt)" &&
        echo "Publish version is: $PUBLISH_VER" &&
        echo "PUBLISH_VER=${PUBLISH_VER}" >> .env
      fi;

.cleanup:monorepo:
  after_script:
    # This varialbe PUBLISH_VER is very essential for deploy stage
    # As it plays a role like version we will deploy
    - >
      export PUBLISH_VER="";
      if [ -f "$PROJECT_PATH/build/publishSummary.txt" ]; then
        PUBLISH_VER="$(cat $PROJECT_PATH/build/publishSummary.txt)" &&
        echo "Publish version is: $PUBLISH_VER" &&
        echo "PUBLISH_VER=${PUBLISH_VER}" >> .env
      fi;


.gradle3.build.backend:
  stage: build
  extends:
    - .master
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:3.5-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd $CI_PROJECT_NAME
    - gradle build --info --stacktrace
  tags:
    - docker
  allow_failure: false


.gradle4.build.backend:
  stage: build
  extends:
    - .master
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:4.6-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd $CI_PROJECT_NAME
    - gradle clean build --info --stacktrace $BUILD_XARG
  tags:
    - docker
  allow_failure: false


.gradle5.build.backend:
  stage: build
  extends:
    - .testroot
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:5.6.1-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd test-root
    - gradle :$CI_PROJECT_NAME:clean :$CI_PROJECT_NAME:build --info --stacktrace $BUILD_XARG
  tags:
    - docker
  allow_failure: false


.gradle6.build.backend:monorepo:
  stage: build
  extends:
    - .testroot:monorepo
    - .cleanup:monorepo
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:6.2.2-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/$PROJECT_PATH/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/$PROJECT_PATH/conf-sample $CI_PROJECT_NAME/$PROJECT_PATH/conf
      fi
    - cd test-root
    - gradle :$projectExecution:clean :$projectExecution:build --info --stacktrace $BUILD_XARG
  tags:
    - docker
  allow_failure: false


.gradle3.distribution.backend:
  stage: build
  extends:
    - .master
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:3.5-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd $CI_PROJECT_NAME
    - gradle distCombined --info --stacktrace $BUILD_XARG
  tags:
    - docker
  artifacts:
    paths:
      - build/
    expire_in: 1 week
  allow_failure: false


.gradle4.distribution.backend:
  stage: build
  extends:
    - .master
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:4.6-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd $CI_PROJECT_NAME
    - gradle clean dist${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  tags:
    - docker
  artifacts:
    paths:
      - build/
    expire_in: 1 week
  allow_failure: false


.gradle5.distribution.backend:
  stage: build
  extends:
    - .testroot
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:5.6.1-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd test-root
    - gradle :$CI_PROJECT_NAME:clean :$CI_PROJECT_NAME:dist${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  tags:
    - docker
  artifacts:
    paths:
      - build/
    expire_in: 1 week
  allow_failure: false

.gradle6.distribution.backend:monorepo:
  stage: build
  extends:
    - .testroot:monorepo
    - .cleanup:monorepo
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:6.2.2-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/$PROJECT_PATH/conf-sample" ]; then
        cp -fr $$CI_PROJECT_NAME/$PROJECT_PATH/conf-sample $CI_PROJECT_NAME/$PROJECT_PATH/conf
      fi
    - cd test-root
    - gradle :$projectExecution:clean :$projectExecution:dist${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  tags:
    - docker
  artifacts:
    paths:
      - build/
    expire_in: 1 week
  allow_failure: false


.gradle3.publish:
  stage: build
  extends:
    - .master
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:3.5-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd $CI_PROJECT_NAME
    - gradle clean pub${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  artifacts:
    reports:
      dotenv: .env
  tags:
    - docker
  allow_failure: false


.gradle4.publish:
  stage: build
  extends:
    - .master
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:4.6-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd $CI_PROJECT_NAME
    - gradle clean pub${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  artifacts:
    reports:
      dotenv: .env
  tags:
    - docker
  allow_failure: false


.gradle5.publish:
  stage: build
  extends:
    - .testroot
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:5.6.1-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd test-root
    - gradle :$CI_PROJECT_NAME:clean :$CI_PROJECT_NAME:publish${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  artifacts:
    reports:
      dotenv: .env
  tags:
    - docker
  allow_failure: false


.gradle6.publish:monorepo:
  stage: build
  extends:
    - .testroot:monorepo
    - .cleanup:monorepo
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:6.2.2-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/$PROJECT_PATH/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/$PROJECT_PATH/conf-sample $CI_PROJECT_NAME/$PROJECT_PATH/conf
      fi
    - cd test-root
    - gradle :$projectExecution:clean :$projectExecution:publish${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  artifacts:
    reports:
      dotenv: .env
  tags:
    - docker
  allow_failure: false


.gradle5.publish.deploy:
  stage: build
  extends:
    - .testroot
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:5.6.1-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd test-root
    - gradle :$CI_PROJECT_NAME:clean :$CI_PROJECT_NAME:publishDeploy${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  artifacts:
    reports:
      dotenv: .env
  tags:
    - docker
  allow_failure: false


.gradle6.publish.deploy:monorepo:
  stage: build
  extends:
    - .testroot:monorepo
    - .cleanup:monorepo
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:6.2.2-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/$PROJECT_PATH/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/$PROJECT_PATH/conf-sample $CI_PROJECT_NAME/$PROJECT_PATH/conf
      fi
    - cd test-root
    - gradle :$projectExecution:publishDeploy${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  artifacts:
    reports:
      dotenv: .env
  tags:
    - docker
  allow_failure: false


.jekyll.build:
  stage: build
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/custom:jekyll-4.1.0
  script:
    - bundle install
    - bundle exec jekyll build
  tags:
    - docker
  allow_failure: false

